unit TCP_Server;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, StdCtrls, ComCtrls;

type
  TTCPServer = class(TForm)
    btListen: TButton;
    edLocalPort: TEdit;
    mbReceiveData: TMemo;
    btStopListen: TButton;
    StatusBar1: TStatusBar;
    Label2: TLabel;
    Label4: TLabel;
    ServerSocket1: TServerSocket;
    procedure btListenClick(Sender: TObject);
    procedure btStopListenClick(Sender: TObject);
    procedure OnListen(Sender: TObject; Socket: TCustomWinSocket);
    procedure OnClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure OnClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure OnClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  TCPServer: TTCPServer;

implementation

{$R *.DFM}

//start server listening by button click
procedure TTCPServer.btListenClick(Sender: TObject);
begin
  If edLocalPort.Text <> '' Then
  begin
    ServerSocket1.Port := strtoint(edLocalPort.Text);
    ServerSocket1.Open;
  end
  Else ShowMessage ('No local port!');
end;

//event handling and display connection state
procedure TTCPServer.OnListen(Sender: TObject; Socket: TCustomWinSocket);
begin
  Statusbar1.SimpleText := 'Listening';
  btStopListen.Enabled := true;
  btListen.Enabled := False;
end;

procedure TTCPServer.OnClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Statusbar1.simpletext := inttostr(ServerSocket1.Socket.ActiveConnections-1) + ' Client(s) connected';
end;

//error handling
procedure TTCPServer.OnClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ShowMessage ('Connection Error');
  ErrorCode := 0;
  ServerSocket1.Close;
  btStopListen.Enabled := False;
  btListen.Enabled := True;
  Statusbar1.SimpleText := 'Stoped Listening';
end;

//receive data handling
procedure TTCPServer.OnClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  connectioncount : integer;
  receivestring : string;
begin
  for connectioncount := 0 to ServerSocket1.Socket.ActiveConnections-1 do
  begin
    with ServerSocket1.Socket.Connections[connectioncount] do
    begin
      receivestring := ReceiveText;
      if receivestring <> '' then
      begin
        mbReceiveData.Text := mbReceiveData.Text + RemoteAddress + ' : ' + receivestring;
      end;
    end;
  end;
end;
//end connection from server side by button click
procedure TTCPServer.btStopListenClick(Sender: TObject);
begin
  ServerSocket1.Close;
  btListen.Enabled := True;
  btStopListen.Enabled := False;
  Statusbar1.SimpleText := 'Stoped Listening';
end;

procedure TTCPServer.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Statusbar1.simpletext := inttostr(ServerSocket1.Socket.ActiveConnections) + ' Client(s) connected';
end;

end.
